
/******************************************************************************
* The MIT License
*
* Copyright (c) 2017 Paul Young
*
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use, copy,
* modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
* BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
* ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*****************************************************************************/
// Code PracticeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Code Practice.h"
#include "Code PracticeDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CCodePracticeDlg dialog



CCodePracticeDlg::CCodePracticeDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_CODEPRACTICE_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_keyer_type = KEYER_TYPE_UNKNOWN;
	m_port = -1;
	m_clear_received_text = false;
	m_speed_up = false;
	m_speed_down = false;
}

void CCodePracticeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPEED_TEXT, m_speed_text);
	DDX_Control(pDX, IDC_FARNSWORTH_TEXT, m_farnsworth_text);
	DDX_Control(pDX, IDC_VOLUME_TEXT, m_volume_text);
	DDX_Control(pDX, IDC_FREQUENCY_TEXT, m_frequency_text);
	DDX_Control(pDX, IDC_SPEED_SLIDER, m_speed_slider);
	DDX_Control(pDX, IDC_FARNSWORTH_SLIDER, m_farnsworth_slider);
	DDX_Control(pDX, IDC_VOLUME_SLIDER, m_volume_slider);
	DDX_Control(pDX, IDC_FREQUENCY_SLIDER, m_frequency_slider);
	DDX_Control(pDX, IDC_FARNSWORTH_CHECK, m_farnsworth_check);
	DDX_Control(pDX, IDC_SUCCESS_CHECK, m_success_check);
	DDX_Control(pDX, IDC_SPEED_CHECK, m_speed_check);
	DDX_Control(pDX, IDC_WORD_TEXT, m_word_text);
	DDX_Control(pDX, IDC_RECEIVED_TEXT, m_received_text);
	DDX_Control(pDX, IDC_STATUS_TEXT, m_status_text);
	DDX_Control(pDX, IDC_VOLUME_STATIC, m_volume_static);
	DDX_Control(pDX, IDC_FREQUENCY_STATIC, m_frequency_static);
	DDX_Control(pDX, IDC_FARNSWORTH_STATIC, m_farnsworth_static);
	DDX_Control(pDX, IDC_SPEED_STATIC, m_speed_static);
	DDX_Control(pDX, IDC_PLAY, m_play_button);
	DDX_Control(pDX, IDC_SETUP, m_setup_button);
}

BEGIN_MESSAGE_MAP(CCodePracticeDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_NEW_WORD, &CCodePracticeDlg::OnBnClickedNewWord)
	ON_BN_CLICKED(IDC_PLAY, &CCodePracticeDlg::OnBnClickedPlay)
	ON_BN_CLICKED(IDC_SETUP, &CCodePracticeDlg::OnBnClickedSetup)
	ON_BN_CLICKED(IDC_FARNSWORTH_CHECK, &CCodePracticeDlg::OnBnClickedFarnsworth)
	ON_MESSAGE(KEYER_MSG, &CCodePracticeDlg::OnKeyer)
	ON_BN_CLICKED(IDC_RESET, &CCodePracticeDlg::OnBnClickedReset)
END_MESSAGE_MAP()


// CCodePracticeDlg message handlers

BOOL CCodePracticeDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_speed_slider.SetRange(MIN_SPEED, MAX_SPEED);
	m_farnsworth_slider.SetRange(MIN_SPEED, MAX_SPEED);
	m_volume_slider.SetRange(MIN_VOLUME, MAX_VOLUME);
	m_frequency_slider.SetRange(MIN_FREQUENCY / FREQUENCY_STEP, MAX_FREQUENCY / FREQUENCY_STEP);

	// Make the word large and the received text font a bit larger
	m_word_font.CreatePointFont(600, L"Arial Bold");
	m_word_text.SetFont(&m_word_font);
	m_received_font.CreatePointFont(180, L"Arial");
	m_received_text.SetFont(&m_received_font);

	// Disable the controls until the keyer is connected
	disable_controls();

	// Start the keyer thread
	m_keyer.start(m_hWnd);

	// Start with a random word
	new_word();

	GotoDlgCtrl(&m_setup_button);
	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CCodePracticeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCodePracticeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCodePracticeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void
CCodePracticeDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
//----------------------------------------------------------------------
// Handle a slider being moved
//----------------------------------------------------------------------
{
	if (pScrollBar) {
		UINT id = pScrollBar->GetDlgCtrlID();
		switch (id) {
			case IDC_SPEED_SLIDER:
			{
				int pos = m_speed_slider.GetPos();
				CString buf;
				buf.Format(L"%u", pos);
				m_speed_text.SetWindowText(buf);
				m_keyer.set_speed(pos);
				break;
			}

			case IDC_FARNSWORTH_SLIDER:
			{
				int pos = m_farnsworth_slider.GetPos();
				CString buf;
				buf.Format(L"%u", pos);
				m_farnsworth_text.SetWindowText(buf);
				if (m_farnsworth_check.GetCheck()) {
					m_keyer.set_farnsworth(pos);
				}
				break;
			}

			case IDC_VOLUME_SLIDER:
			{
				int pos = m_volume_slider.GetPos();
				CString buf;
				buf.Format(L"%u", pos);
				m_volume_text.SetWindowText(buf);
				m_keyer.set_volume(pos);
				break;
			}

			case IDC_FREQUENCY_SLIDER:
			{
				int pos = m_frequency_slider.GetPos();
				CString buf;
				buf.Format(L"%u", pos * FREQUENCY_STEP);
				m_frequency_text.SetWindowText(buf);
				m_keyer.set_frequency(pos);
				break;
			}
		}
	}
	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}

void
CCodePracticeDlg::OnBnClickedNewWord()
//----------------------------------------------------------------------
// Select a new word
//----------------------------------------------------------------------
{
	// There is a speed penalty for giving up on a word
	set_speed(-1);
	m_speed_up = false;
	m_speed_down = true;

	new_word();
}

void
CCodePracticeDlg::OnBnClickedPlay()
//----------------------------------------------------------------------
// Send the word
//----------------------------------------------------------------------
{
	m_keyer.send(m_word_pointer, 5);
}

void
CCodePracticeDlg::OnBnClickedFarnsworth()
//----------------------------------------------------------------------
// Set a farnsworth speed
//----------------------------------------------------------------------
{
	if (m_farnsworth_check.GetCheck()) {
		int pos = m_farnsworth_slider.GetPos();
		m_keyer.set_farnsworth(pos);
	}
	else {
		m_keyer.set_farnsworth(0);
	}
}

void
CCodePracticeDlg::OnBnClickedSetup()
//----------------------------------------------------------------------
// Run the setup dialog, set port and keyer type
//----------------------------------------------------------------------
{
	m_setup.set_keyer_type(m_keyer_type);
	m_setup.set_port(m_port);

	if (m_setup.DoModal() == IDOK) {
		m_keyer_type = m_setup.get_keyer_type();
		if (m_keyer_type != KEYER_TYPE_UNKNOWN) {
			m_keyer.set_type(m_keyer_type);
		}
		m_port = m_setup.get_port();
		m_keyer.set_port(m_port);
	}
}

void
CCodePracticeDlg::OnBnClickedReset()
//----------------------------------------------------------------------
// Reset the statistics
//----------------------------------------------------------------------
{
	m_start = GetTickCount64();
	m_correct = 0;
	m_incorrect = 0;
	m_status_text.SetWindowText(L"");
}

LRESULT
CCodePracticeDlg::OnKeyer(WPARAM wParam, LPARAM lParam)
//----------------------------------------------------------------------
// Handle a message from the keyer interface
//----------------------------------------------------------------------
{
	switch ((Keyer_Message)wParam) {
	case KEYER_MESSAGE_CONNECT:
	{
		m_status_text.SetWindowText(L"Connected");
		m_start = GetTickCount64();
		m_correct = 0;
		m_incorrect = 0;

		enable_controls();
		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_DISCONNECT:
	{
		if (lParam == ERROR_SUCCESS) {
			m_status_text.SetWindowText(L"Disconnected");
		}
		else {
			LPVOID msg_buf;
			USHORT index = 0;
			FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER |
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				(DWORD)lParam,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				(LPTSTR)&msg_buf,
				0,
				NULL
			);

			CString err = L"Cannot connect to keyer: ";
			err += (LPCTSTR)msg_buf;
			LocalFree(msg_buf);

			//Trim CR/LF from the error message.
			err.TrimRight();

			m_status_text.SetWindowText(err);
		}

		disable_controls();
		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_CHAR:
	{
		if (lParam < ' ') {
			break;
		}

		// If the text is supposed to be cleared ignore spaces
		if (m_clear_received_text) {
			if (lParam == ' ') {
				break;
			}
			m_clear_received_text = false;
			m_received.Empty();
		}

		// Display what the user or computer sent.  Don't show
		// spaces at the end because it wipes out the characters
		// which were sent.  And don't take computer-sent
		// code as successful.
		m_characters++;
		m_received += (char)lParam;
		m_received = m_received.Right(5);
		if ((m_received.GetLength() < 5) || (lParam != ' ')) {
			m_received_text.SetWindowText(m_received);
		}

		if ((m_received == m_word) && !m_keyer.get_paddle()) {
			if (m_characters == 5) {
				m_received_text.SetWindowText(L"Perfect");
				m_correct++;
				if (m_speed_up) {
					set_speed(1);
				}
				else {
					m_speed_down = false;
					m_speed_up = true;
				}
				show_statistics();
				m_word_scored = true;
			}
			else {
				m_received_text.SetWindowText(L"OK");
				if (!m_word_scored) {
					m_incorrect++;
					if (m_speed_down) {
						set_speed(-1);
					}
					else {
						m_speed_down = true;
						m_speed_up = false;
					}
					show_statistics();
					m_word_scored = true;
				}
			}
			if (m_success_check.GetCheck()) {
				new_word();
			}
			m_clear_received_text = true;
		}

		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_FARNSWORTH:
	{
		if (lParam) {
			m_farnsworth_check.SetCheck(TRUE);
			m_farnsworth_slider.SetPos((DWORD)lParam);
		}
		else {
			m_farnsworth_check.SetCheck(FALSE);
		}
		CString buf;
		buf.Format(L"%u", lParam);
		m_farnsworth_text.SetWindowText(buf);

		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_FREQUENCY:
	{
		m_frequency_slider.SetPos((DWORD)lParam / 10);
		CString buf;
		buf.Format(L"%u", lParam);
		m_frequency_text.SetWindowText(buf);

		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_SPEED:
	{
		// This is a message that the keyer pot speed changed.
		// Change the actual keyer speed to match.
		m_keyer.set_speed((DWORD)lParam);

		m_speed_slider.SetPos((DWORD)lParam);
		CString buf;
		buf.Format(L"%u", lParam);
		m_speed_text.SetWindowText(buf);

		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_TYPE:
	{
		if (lParam <= KEYER_TYPE_DAH) {
			m_keyer_type = (Keyer_Type)lParam;
		}
		else {
			m_keyer_type = KEYER_TYPE_DEFAULT;
		}

		reset_display_idle_timer();
		break;
	}

	case KEYER_MESSAGE_VOLUME:
	{
		m_volume_slider.SetPos((DWORD)lParam);
		CString buf;
		buf.Format(L"%u", lParam);
		m_volume_text.SetWindowText(buf);

		reset_display_idle_timer();
		break;
	}

	}

	return TRUE;
}

void
CCodePracticeDlg::set_speed(int delta)
//----------------------------------------------------------------------
// Change the keyer speed
//----------------------------------------------------------------------
{
	if (m_speed_check.GetCheck()) {
		unsigned int speed = m_speed_slider.GetPos() + delta;
		if ((speed >= MIN_SPEED) && (speed <= MAX_SPEED)) {
			m_speed_slider.SetPos(speed);
			CString buf;
			buf.Format(L"%u", speed);
			m_speed_text.SetWindowText(buf);
			m_keyer.set_speed(speed);
		}
	}
}

void
CCodePracticeDlg::new_word()
//----------------------------------------------------------------------
// Select and display a new random word
//----------------------------------------------------------------------
{
	m_word_pointer = m_words.get_word();
	m_word = m_word_pointer;
	m_word_text.SetWindowText(m_word);
	m_word_scored = false;
	m_characters = 0;
}

void
CCodePracticeDlg::show_statistics()
//----------------------------------------------------------------------
// Display the statistics
//----------------------------------------------------------------------
{
	ULONGLONG now = GetTickCount64();

	unsigned int seconds = (unsigned int)((now - m_start + 500) / 1000);
	int total = m_correct + m_incorrect;
	if (!total) {
		return;
	}

	float seconds_per = (float)seconds / (float)total;
	int first_try = ((m_correct * 100) + (total / 2)) / (total);
	CString stats;
	stats.Format(L"%d Words, %2.1F seconds/word, %d%% correct", total, seconds_per, first_try);
	m_status_text.SetWindowText(stats);
}

void
CCodePracticeDlg::enable_controls()
//----------------------------------------------------------------------
// Enable the controls because the keyer is connected
//----------------------------------------------------------------------
{
	m_speed_slider.EnableWindow(TRUE);
	m_speed_static.EnableWindow(TRUE);
	m_speed_text.EnableWindow(TRUE);

	m_farnsworth_slider.EnableWindow(TRUE);
	m_farnsworth_static.EnableWindow(TRUE);
	m_farnsworth_text.EnableWindow(TRUE);
	m_farnsworth_check.EnableWindow(TRUE);

	m_volume_slider.EnableWindow(TRUE);
	m_volume_static.EnableWindow(TRUE);
	m_volume_text.EnableWindow(TRUE);

	m_play_button.EnableWindow(TRUE);

	if (m_keyer.get_model() == KEYER_MODEL_TEN_DOLLAR) {
		m_frequency_slider.EnableWindow(TRUE);
		m_frequency_static.EnableWindow(TRUE);
		m_frequency_text.EnableWindow(TRUE);
	}

	// TODO:  Change the frequency information based on the
	// keyer model.
}

void
CCodePracticeDlg::disable_controls()
//----------------------------------------------------------------------
// Disable the controls because the keyer is not connected
//----------------------------------------------------------------------
{
	m_speed_slider .EnableWindow(FALSE);
	m_speed_static.EnableWindow(FALSE);
	m_speed_text.EnableWindow(FALSE);

	m_farnsworth_slider.EnableWindow(FALSE);
	m_farnsworth_static.EnableWindow(FALSE);
	m_farnsworth_text.EnableWindow(FALSE);
	m_farnsworth_check.EnableWindow(FALSE);

	m_volume_slider .EnableWindow(FALSE);
	m_volume_static.EnableWindow(FALSE);
	m_volume_text.EnableWindow(FALSE);

	m_play_button.EnableWindow(FALSE);

	m_frequency_slider.EnableWindow(FALSE);
	m_frequency_static.EnableWindow(FALSE);
	m_frequency_text.EnableWindow(FALSE);
}