/******************************************************************************
* The MIT License
*
* Copyright (c) 2017 Paul Young
*
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use, copy,
* modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
* BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
* ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
* CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*****************************************************************************/

// Setup.cpp : implementation file
//

#include "stdafx.h"
#include "Code Practice.h"
#include "Setup.h"
#include "afxdialogex.h"


// CSetup dialog

IMPLEMENT_DYNAMIC(CSetup, CDialogEx)

CSetup::CSetup(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_SETUP, pParent)
	, m_keyer_type(0)
	, m_port_sel(-1)
{

}

CSetup::~CSetup()
{
}

void CSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_IAMBIC_A, m_keyer_type);
	DDX_Control(pDX, IDC_PORT, m_port);
}


BEGIN_MESSAGE_MAP(CSetup, CDialogEx)
END_MESSAGE_MAP()

BOOL
CSetup::OnInitDialog()
//----------------------------------------------------------------------
// Set the initial values of the controls
//----------------------------------------------------------------------
{
	CDialogEx::OnInitDialog();

	for (int i = 1; i <= 32; i++) {
		CString temp;
		temp.Format(L"COM%d", i);
		m_port.AddString(temp);
	}

	m_port.SetCurSel(m_port_sel);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void
CSetup::OnOK()
//----------------------------------------------------------------------
// Store the values of the controls so the caller can access them
//----------------------------------------------------------------------
{
	m_port_sel = m_port.GetCurSel();

	CDialogEx::OnOK();
}